**************************** MENU V&V *************************************
*** Procedure menu   version 1.0
*** Copyright 1990, CRAIG KIMPEL
***
***************************************************************************

set talk off
clear all
on escape suspend

clear
* set color scheme for a composite terminal
* or restore defaults
set border to '','','','','','','','','','','','','','','',''
if type('b_w_term')='L'.AND.b_w_term
   set color of scheme 1 to W/N,N+/W,W+/N,W+/N,W/N,N+/W,N+/W,n+/n,W+/N,W/N
   set color of scheme 2 to W/N,W+/N,W+/N,W+/N,W/N,N+/W,N+/W,n+/n,W+/N,W/N
   set color of scheme 3 to N/W,N/W,N/W,W+/N,N+/W,W+/N,N+/W,n+/n,W+/N,N+/W
   set color of scheme 4 to W/N,W+/N,W+/N,W+/N,W/N,N+/W,N+/W,n+/n,W+/N,W/N
   set color of scheme 5 to W/N,W+/N,W+/N,W+/N,W+/N,N+/W,N+/W,n+/n,W+/N,W/N
   set color of scheme 6 to W/N,W+/N,W+/N,W+/N,W+/N,N+/W,N+/W,n+/n,W+/N,W/N
   set color of scheme 7 to N+/W,N/W,N/W,N+/W,N/W,W+/N,N+/W,n+/n,N+/W,N/W
   set color of scheme 8 to W/N,N+/W,N/W,N+/W,N/W,N/W,N+/N,n+/n,W+/N,W/N
   set color of scheme 9 to W/N,W+/N,W+/N,N+/W,N/W,N/W,N/W,n+/n,N+/W,N/W
   set color of scheme 10 to W/N,N+/W,N/W,N+/W,N/W,N+/W,N/W,n+/n,N+/W,N/W
   set color of scheme 11 to W+/N,N+/W,N/W,N+/W,N/W,N/W,W/N,n+/n,N/W,W/N
else
   set color of scheme 1 to
   set color of scheme 2 to
   set color of scheme 3 to
   set color of scheme 4 to
   set color of scheme 5 to
   set color of scheme 6 to
   set color of scheme 7 to
   set color of scheme 8 to
   set color of scheme 9 to
   set color of scheme 10 to
   set color of scheme 11 to
endif

for a=1 to 11
   sch = 'schdflt'+right('0'+ltrim(str(a)),2)
   &sch = scheme(a)
endfor
develop = .T.
define window ex1 from 10,30 to 22,79
activate window ex1
clear
clr6 = scheme(2,6)
clr2 = scheme(2,2)
clr1 = scheme(2,1)
clr7 = scheme(2,7)
set color to &clr6
@ 0,0   say 'Test1'
set color to &clr2
@ 2,0   say 'tEst2'
@ 10,10 say 'tesT4'
@ 10,16 say 'test5'
set color to &clr1
@ 2,20  say 'teSt3'
set color to &clr7
@ 2,1 say 'E'
@ 10,13 say 'T'
@ 10,20 say '5'
set color of scheme 1 to &SchDflt01
set color of scheme 2 to &SchDflt02
do disp_msg_ with 'Press any key to start'+chr(13)+'The screen will show a menu = to the window below,'+chr(13)+'with Test1 highlighted and teSt3 disabled.'+chr(13)+chr(13);
                  +'Press the right arrow and the highlight should cycle counterclockwise.'+chr(13)+'Press the left arrow and the highlight should cycle clockwise.'+chr(13)+'Press CTRL-W to continue',900
activate screen
clear
clear typeahead
do menu_op with 'TEST'
release window ex1
do disp_msg_ with 'Now, Highlight each menu item and press enter and spacebar.'+chr(13)+'A window should popup, with the value of each prompt.'+chr(13)+'Press Ctrl-W to continue',900
do menu_op with 'TEST'
do disp_msg_ with 'Now, Press the up/down/page up/and page down keys.'+chr(13)+'The values UPARROW/DNARROW/PAGEUP/PAGEDOWN should be displayed.'+chr(13)+chr(13)+'Press Ctrl-W to exit this test',900
do menu_op with 'TEST'
set color of scheme 1 to W/N
clear
if type('b_w_term')<>'U'.AND.b_w_term
   do disp_msg_ with 'This time, the call was made to highlight teSt3,\nwhich is unselectable.\nHowever, the highlighted prompt should be tesT4.'+chr(13)+'The message line should be the 2nd line on the screen.'+chr(13);
                  +'The message line should be left justified.'+chr(13)+'The prompts should be W/N.'+chr(13)+'The highlighted prompt should be N+/W.'+chr(13)+'teSt3 should be N+/N.'+chr(13)+'The message line should be W/N.'+chr(13);
                  +'The first call to the menu routine was with teSt3 selected.'+chr(13)+'All other calls will be with tesT4 selected, from history.'+CHR(13)+'Press ctrl-W to exit this test',999,.F.,.F.,.F.,24,.F.,'LL'
   do menu_op with 'TEST',3,1,'ACTIVATE','L','W/N','N+/W','N+/W','N+/N','W/N'
else
   do disp_msg_ with 'This time, the call was made to highlight teSt3,\nwhich is unselectable.\nHowever, the highlighted prompt should be tesT4.'+chr(13)+'The message line should be the 2nd line on the screen.'+chr(13);
                  +'The message line should be left justified.'+chr(13)+'The prompts should be N/BG.'+chr(13)+'The highlighted prompt should be N/BG*.'+chr(13)+'teSt3 should be N+/N.'+chr(13)+'The message line should be W/N.'+chr(13);
                  +'The first call to the menu routine was with teSt3 selected.'+chr(13)+'All other calls will be with tesT4 selected, from history.'+CHR(13)+'Press ctrl-W to exit this test',999,.F.,.F.,.F.,24,.F.,'LL'
   do menu_op with 'TEST',3,1,'ACTIVATE','L','N/BG','W+/BG','N/BG*','N+/N','W/N'
endif
set color of scheme 1 to W/N
clear
do disp_msg_ with 'Press enter, and the same menu will be called,\n with color scheme 7 set,\n by setting only the first color parameter to 7.\n\nPress CTRL-W to exit this test',900
do menu_op with 'TEST',3,1,'ACTIVATE','L',7
set color of scheme 1 to W/N
clear
do disp_msg_ with 'Press enter, and the same menu will be called,\n with color paramters from schemes 1,2,3,4,5.\nBy setting each parameter, to a different scheme.',900
do menu_op with 'TEST',3,1,'ACTIVATE','L',1,2,3,4,5
do disp_msg_ with 'Press enter, and the screen will clear.'+chr(13)+'Then the screen will show only, the selected menu item,'+chr(13)+'and the message line right justified,'+chr(13)+'because the menu was not redrawn, with the redraw parameter.'+chr(13);
                  +'Also the colors will remain the same, from history,'+chr(13)+'since the previously called colors, were not changed on this call.'+chr(13)+chr(13)+'Press Ctrl-W to exit this test',900
set color of scheme 1 to W/N
clear
do menu_op with 'TEST',.F.,.F.,.F.,'R'
do disp_msg_ with 'Press enter, and a new menu will be called,'+chr(13)+'which will create new defaults.'+chr(13)+'Also, one message line is to long, and an error message will be displayed.'+chr(13)+chr(13)+'Press Ctrl-W to exit this test',900
set color of scheme 1 to W/N
set color of scheme 2 to &SchDflt02
clear
do menu_op with 'TEST1'
do disp_msg_ with 'Press enter again, and the screen will be cleared,'+chr(13)+'then the same menu will be called, with the redraw parameter on,'+chr(13)+'which will redraw the menu.'+chr(13);
                  +'Also, one message line is to long. However, no error message will be displayed,'+chr(13)+'since it is called from the previous messages history.'+chr(13)+chr(13)+'Press Ctrl-W to exit this test',900
set color of scheme 1 to W/N
clear
do menu_op with 'TEST1',.F.,.F.,.F.,.F.,.F.,.F.,.F.,.F.,.F.,.T.
do disp_msg_ with 'Press enter again, and the menu variables will be cleared.'+chr(13)+'No PUBLIC variables should be displayed.',900
a = menu_(.F.,.F.,.F.,'RELEASE')
=inkey()
set color of scheme 1 to w/n
if ''<>a
   do disp_msg_ with 'Error in clearing memory variables',900
endif
display memory
clear
do disp_msg_ with 'Now, the same menu test1 will be called.\nInside of a window,\nno parameters were changed,\njust an activate window test from 8,10 to 22,70 prior to the call.\n\nPress ctrl-W to exit this test',900
set color of scheme 1 to &SchDflt01
set color of scheme 2 to &SchDflt02
define window test from 8,10 to 22,70
activate window test
do menu_op with 'TEST1'
release window test
clear

*****************************************************************************
*** Procedure menu_op    version 1.0
*** Copyright 1990, CRAIG KIMPEL
***
*****************************************************************************

procedure menu_op
parameter param1,param2,param3,param4,param5,param6,param7,param8,param9,param10,param11

* this procedure is just an interface between the disp_msg and menu procedure
*   With the sole purpose of supporting the V&V procedure

do while .T.
   a = menu_(param1,param2,param3,param4,param5,param6,param7,param8,param9,param10,param11)
   if type('param3') = 'N'
      if param2 = 3
         param2 = 4
      endif
   endif
   set console on
   if a = 'CTRL-W'
      exit
   else
      do disp_msg_ with 'Value returned by menu() was '+a,900
      set color to &mdisp_colo
      loop
   endif
enddo

return

*************************************************************************
*** Procedure Disp_msg_     version 1.0 Smart procedure series
*** Copyright 1990, Craig Kimpel
***
*************************************************************************

procedure disp_msg_
parameters message_,time_out,error_,dispos_,out_line,row,col,coord,color_sh,brow_win,capture

****** PARAMETERS ******

*** GLOBAL ***
* b_w_term =<expL> if true force Black and white color defaults
               * if false check iscolor() to determine default colors

*** LOCAL PASSED PARAMETERS ***
* message_ =<expC> message string to display, may be embedded with chr(13)'s
* time_out =<expN.N> number of seconds to wait for a key press, decimals allowed
*** time_out = 999 leaves message window on screen for calling routine to release when not needed
*** time_out = 999 .AND. BROW_WIN SET - transfers message window to the background screen
***                                     sorry but that is the best workaround I could find 
* error_   =<expL> Beep the display
* dispos_  =<expC> 1 char disposition of string, L->eft, R->ight anything else->Center.
* out_line =<expC> 1 char or 2 char string D->ouble,S->ingle,P->anel,SY->stem,N->one
              * default double unless terminal error_ which is panel
* row      =<expn> Force the row coordinate (default iif(row()>12,2,13)
* col      =<expN> Force the column coordinate (default center)
* coord    =<expC> (default 'UL'
              * 'UL' = upper left corner
              * 'UR' = upper right corner
              * 'LL' = lower left corner
              * 'LR' = lower right corner
* color_sh  =<expC COLOR SCHEME> color scheme to use for window (default R/W color, W+/W black&white)
*           =<expN SCHEME NUMBER> color scheme number
* brow_win  =<expL> Active window on entrance was a browse, This will prevent closure of the browse window upon exiting
* capture   =<expL> Capture the key pressed ( Do not place in keyboard buffer )

*** LOCAL DEFINED PARAMETERS ***
* Window err_win is not killed before return if time_out=999

* save status for later
private save_win,save_color
save_win = woutput()
save_color = scheme(1)

* define needed variables if not passed to procedure
* b_w_term is a parameter in main calling routine to force noncolor when a composite monitor is used.
if type('b_w_term')='U'
   private all
   b_w_term = .not.iscolor()
else
   private all except b_w_term
endif

* Take care of the talk status
if set('TALK') = 'ON'
   set talk off
   save_talk = 'ON'
else
   save_talk = 'OFF'
endif

* set defaults if not passed
if type('message_')='L'
   message_ = 'Press any key to continue'
endif
if type('time_out')='L'
   time_out = 10
endif
if type('dispos_')='L'
   dispos_ = 'C'
endif
if type('out_line')='L'
   if error_
      out_line = 'P'
   else
      out_line = 'D'
   endif
endif
if type('coord')='L'
   coord = 'UL'
endif

do case
   case type('color_sh') = 'L' 
      * make color noticable if not defined
      if iscolor().and..not.b_w_term
         set color of scheme 1 to r/w,,r/w
      else
          set color of scheme 1 to w+/w,,w+/w
      endif
   case type('color_sh') = 'N'
      color_sh = ltrim(str(color_sh))
      set color of scheme 1 to scheme &color_sh
   case type('color_sh') = 'C'
      if at(',',color_sh)=0
         color_sh = color_sh+',,'+color_sh
      endif
      set color of scheme 1 to &color_sh
endcase


* BEEP terminal if requested
if error_
   save_con = sys(100)
   set console on
   ?? chr(7)
   set console &save_con
endif

* Parse message into array mess_() using chr(13) as a separator
* longmess_ = length of longest array mess_() string
* a         = array counter

a=1
b=1
longmess_ = 0
* determine number of variables needed
do while at(chr(13),message_,a)<>0
   a = a+1
enddo
do while at('\n',message_,b)<>0
   b = b+1
enddo
a = a+b && already accounted for last message which has an implicit chr(13)
* dynamically create message array
dimension mess_(a)
* reset array counter
a=1
* parse message into array and set longmess_
do while chr(13) $ message_.OR. '\n' $ message_
   found_ = min(at(chr(13),message_),at('\n',message_))
   * if one or the other is not found take the max
   if found_ = 0
      found_ = max(at(chr(13),message_),at('\n',message_))
   endif   
   mess_(a)=alltrim(left(message_,found_-1))
   * account for the different lengths of teh string seperators
   if substr(message_,found_,1) = chr(13)
      message_ = right(message_,len(message_)-found_)
   else
      message_ = right(message_,len(message_)-found_-1)
   endif
   * store the maximium string length to determine the size of the window
   if len(mess_(a))>longmess_
      longmess_ = len(mess_(a))
   endif
   a = a+1
enddo
mess_(a)=alltrim(message_) && store last message
if len(mess_(a))>longmess_ && set max string length if last message is the longest
   longmess_ = len(mess_(a))
endif

* find leftx,topy of window based on current cursor row
if type('row')='L'
   if row()>12
      row_ = 2
   else
      row_ = 13
   endif
else
   row_ = row
endif
* leave room for the 2 character border
if type('col') = 'L'
   col_ = 39-longmess_/2
else
   col_ = col
endif


if wexist('err_win')
   release window err_win
endif

* adjust the row_ and col_ coordinates to relative 'UL' if needed
if left(coord,1) = 'L'
   row_ = row_-a-1
endif
if right(coord,1) = 'R'.AND.type('col')<>'L'
   col_ = col_-longmess_-1
endif

if wexist('ERR_WIN')
   release window err_win
endif

do case
   case out_line = 'D'
      define window err_win from row_,col_ to row_+a+1,col_+longmess_+1 shadow double
   case out_line = 'SY'
      define window err_win from row_,col_ to row_+a+1,col_+longmess_+1 shadow system
   case out_line = 'S'
      define window err_win from row_,col_ to row_+a+1,col_+longmess_+1 shadow 
   case out_line = 'P'
      define window err_win from row_,col_ to row_+a+1,col_+longmess_+1 shadow panel
   case out_line = 'N'
      define window err_win from row_,col_ to row_+a-1,col_+longmess_+1 shadow none
endcase
activate window err_win
* post message in window based on disposition variable
for a=1 to a
   do case
   case upper(dispos_) = 'L'
      y_pos = 0
   case upper(dispos_) = 'R'
      y_pos = longmess_-len(mess_(a))
   otherwise && center message
      y_pos = (longmess_-len(mess_(a)))/2
   endcase
   @ a-1,y_pos say mess_(a)
endfor

if brow_win.AND.time_out=999
   * this is  the long drawnout workaround to a problem that should have been solved below
   define window err_win1 from row_,col_ to row_+1,col_+1 && make dummy window
   activate window err_win1 bottom && set up winodw stack
   activate screen && needed to make the hide err_win save work
   hide window err_win save && do it
   deactivate window err_win && remove from the window stack
   activate window err_win1 bottom && point to next member of the window stack
   release window err_win1 && remove from stacj to activate browse window
   release window err_win && image was transfered to the background screen
   
   * work that should work !!!!!!!!!!!!!!!!!!
   * deactivate window err_win && to make browse window active again
   * show window err_win && to keep window displayed on the screen upon exit
   * HOWEVER, FOXPRO clears a the window contents when deactivating it.
   * and the show window command displays a clear window ????????????
endif
if time_out <> 999
   clear typeahead
   if capture
      =inkey(time_out)
   else
      =chrsaw(time_out)
   endif
   release window err_win
endif
* calling routine needs to release err_win when appropriate
* needed to prevent exit from an active browse
if .NOT.brow_win
   if ''=save_win
      activate screen
   else
      activate window &save_win
   endif
endif


set talk &save_talk
set color of scheme 1 to &save_color

return

*
********************************************************************************
*** Procedure Menu_     version 1.0
*** Copyright 1990, CRAIG KIMPEL
***
********************************************************************************

procedure menu_
parameter menu_name,start_pos,message_line,action,message_place,disp_color,hot_color,sel_color,unsel_color,mess_color,redraw,help,help_file,help_update

****** PARAMETERS ******

*** GLOBAL ***
* NONE

*** LOCAL PASSED PARAMETERS ***

    *** if confirm need set confirm on prior to calling this routine
    * menu_name     = name of menu to activate ( Calling a different menu than previous resets default parameters )
    * start_pos     = numerical position of highlighted menu item
    * message_line  = line to place the messages on
    * action        = ( Always defaults to ACTIVATE )
                       * activate = use menu ( dynamically defines menu if needed )
                       * release  = take menu variables off of stack
    * message_place =
                       * C = Center the message on the line
                       * L = Left justify the message on the line
                       * R = Right justify the message on the line
    * disp_color    = the color to use on displayed menu items ( Forces menu redraw if changed from previous call )
    *                 defaults to scheme 2,2 colors
    *                 if number, uses menu color pair for that scheme
    *                 if number and all other colors are logical, sets all other to this same scheme number
    * hot_color     = the color to use for the hot keys
    *                 defaults to scheme 2,7 colors
    *                 if number, uses menu color pair for that scheme
    * unsel_color   = the color to use on unselectable menu items ( Forces menu redraw if changed from previous call )
    *                 defaults to scheme 2,1 colors
    *                 if number, uses menu color pair for that scheme
    * sel_color     = the highlite color to use on the currently seleced menu item ( Forces menu redraw if changed from previous call )
    *                 defaults to scheme 2,6 colors
    *                 if number, uses menu color pair for that scheme
    * mess_color    = the color of the message line 
    *                 defaults to scheme 2,5 colors
    *                 if number, uses menu color pair for that scheme
    * redraw        = force menu routine to redraw the menu ( This parameter always default to .F. )
    * help          = Call the help_ procedure if enabled
    * help_file     = DBF file name to use in the help_ procedure
    *                 defaults to HELP.DBF
    * help_update   = if .T. update of help text allowed
    *                 if .F. display of help text only


*** LOCAL DEFINED PARAMETERS ***
* All in procedure call menu_defs_

* Limitations
     * maximium number of pads = 40

* #INCLUDE disp_msg_ (needed for display of error messages)

* function
   * Display a menu bar with pads in the current output window
   *    and allow for processing of any keyboard input via the inkey fuction

* specifics
   * right arrow moves to next pad
   * left arrow moves to previous pad
   * enter selects pad
   * spacebar selects pad
   * returns text value of the pad, or text value of trapped key (ie. 'PAGEUP')

* variables
   * col_accul = accumulative column position
   * pads(x,y) = pad characteristics (y1 = prompt, y2=message, y3=row, y4=col)
   * pads(x,3).AND.pads(x,4) = if neither are declared -> uses the previous row for row and the previous column + len(previous prompt) for column
   * pads(x,3) = if not declared -> it uses the same as previous row or 0 if first row
   * pads(x,4) = if not declared -> it uses the same as the previous column + length of previous prompt + 1, if first column then uses 0

* uses only one pad array variable to conserve the number of variables used

save_cursor = set('CURSOR')
set cursor off
private savecolor1,savecolor2
savecolor1 = scheme(1)
savecolor2 = scheme(2)
if type('action')='L'
   action = 'ACTIVATE'
endif
if upper(action) = 'RELEASE'
   release pads
   release curr_menu,hotkeys,num_pads
   release mstart_pos,mmessage_line,mmessage_place,mdisp_color,mhot_color,msel_color,munsel_color,mmess_color
   return ''
endif

* set up defaults

set exact on
if type('curr_menu') = 'U'.OR.curr_menu<>upper(menu_name) && create or adjust defaults
   if type('mess_color') = 'L'
      mess_color = scheme(2,5)
   endif
   if type('unsel_color') = 'L'
      unsel_color = scheme(2,1)
   endif
   if type('sel_color') = 'L'
      sel_color = scheme(2,6)
   endif
   if type('disp_color') = 'L'
      disp_color = scheme(2,2)
   endif
   if type('hot_color') = 'L'
      hot_color = scheme(2,7)
   endif
   if type('message_place') = 'L'
      message_place = 'C'
   endif
   if type('start_pos')='L'
      start_pos=1
   endif
   if type('message_line') = 'L'
      message_line=set('MESSAGE')
   endif
   if type('menu_name') = 'L'
      do disp_msg_ with 'MUST PASS procedure MENU'+chr(13)+'a menu_name parameter',999,.T.,.F.,.F.,.F.,.F.,.F.,.F.,.F.,.T.
      if develop
         suspend
      else
         cancel
      endif
   endif
   if type('pads')<>'U'
      * reinitalize pads
      pads = .F.
   endif
   public pads(41,4),curr_menu,hotkeys,num_pads
   * extra variables needed to temporarily save the private variabes while relesaed and made public again
   public mstart_pos,mmessage_line,mmessage_place,mdisp_color,mhot_color,msel_color,munsel_color,mmess_color
   mstart_pos = start_pos
   mmessage_line = message_line
   mmessage_place = message_place
   mdisp_color = disp_color
   mhot_color = hot_color
   msel_color = sel_color
   munsel_color = unsel_color
   mmess_color = mess_color
   curr_menu = ''
   hotkeys = ''
else
  if type('disp_color') = 'N'.AND.type('unsel_color') = 'L'.AND.type('sel_color') = 'L'.AND.type('mess_color') = 'L'.AND.type('hot_color') = 'L'
      unsel_color = scheme(disp_color,1)
      sel_color   = scheme(disp_color,6)
      hot_color   = scheme(disp_color,7)
      mess_color  = scheme(disp_color,5)
      disp_color  = scheme(disp_color,2)
   endif
   if type('mess_color') = 'N'
      mess_color = scheme(mess_color,5)
   endif
   if type('unsel_color') = 'N'
      unsel_color = scheme(unsel_color,1)
   endif
   if type('sel_color') = 'N'
      sel_color = scheme(sel_color,6)
   endif
   if type('disp_color') = 'N'
      disp_color = scheme(disp_color,2)
   endif
   if type('hot_color') = 'N'
      hot_color = scheme(hot_color,7)
   endif
   if type('mess_color') = 'L'
      mess_color = mmess_color
   endif
   if type('unsel_color') = 'L'
      unsel_color = munsel_color
   endif
   if type('sel_color') = 'L'
      sel_color = msel_color
   endif
   if type('disp_color') = 'L'
      disp_color = mdisp_color
   endif
   if type('hot_color') = 'L'
      hot_color = mhot_color
   endif
   if type('message_place') = 'L'
      message_place = mmessage_place
   endif
   if type('start_pos')='L'
      start_pos=mstart_pos
   endif
   if type('message_line') = 'L'
      message_line=mmessage_line
   endif
   if type('menu_name') = 'L'
      do disp_msg_ with 'MUST PASS procedure MENU'+chr(13)+'a menu_name parameter',999,.T.
      if develop
         suspend
      else
         cancel
      endif
   endif
endif
set exact off

* save for defaults on next call

* Force redraw of menu if colors changed 
if disp_color<>mdisp_color.OR.unsel_color<>munsel_color.OR.sel_color<>msel_color.OR.redraw
   redraw = .T.
endif

old_pos = mstart_pos && defined here to retain start_pos prior to call
mstart_pos = start_pos
mmessage_line = message_line
mmessage_place = message_place
mdisp_color = disp_color
mhot_color = hot_color
msel_color = sel_color
munsel_color = unsel_color
mmess_color = mess_color
menu_name = upper(menu_name)

do case
   case upper(action) = 'ACTIVATE'
      save_exact = set('EXACT')
      set exact on
      if curr_menu <> menu_name && create variables
         do menu_defs_ 
         pad_num = 1
         do while type('pads(pad_num,1)')<>'L'
              if len(pads(pad_num,2))>wcols()
               do disp_msg_ with 'Message string for message pads('+ltrim(str(pad_num))+',2)'+chr(13)+'is too long for display window'+chr(13)+chr(13)+'Press enter and the display line will be truncated at right of window',900,.F.,.F.,.F.,.F.,.F.,.F.,.F.,.F.,.T.
               pads(pad_num,2) = left(pads(pad_num,2),wcols())
            endif
            hot_loc = at('\<',pads(pad_num,1))
            if hot_loc > 0
               * if '\<' occurs at end of string disable the hot key for that pad
               if (hot_loc<>0.AND.hot_loc+2>len(pads(pad_num,1)))
                  hotkeys = hotkeys + ' '
               else
                  hotkeys = hotkeys + substr(pads(pad_num,1),hot_loc+2,1)
               endif
               pads(pad_num,1) = left(pads(pad_num,1),hot_loc-1)+right(pads(pad_num,1),len(pads(pad_num,1))-hot_loc-1)
            else
               if at('\',pads(pad_num,1)) > 0
                  hotkeys = hotkeys + ' '
                  hot_loc = at('\',pads(pad_num,1))
                  pads(pad_num,1) = '\'+left(pads(pad_num,1),hot_loc-1)+right(pads(pad_num,1),len(pads(pad_num,1))-hot_loc)
               else
                  hotkeys = hotkeys + upper(left(pads(pad_num,1),1))
               endif
            endif
            pad_num = pad_num+1
         enddo
         num_pads = pad_num-1
         if type('pads(1,3)')='L'
            pads(1,3) = 0
         endif
         if type('pads(1,4)')='L'
            pads(1,4) = 0
         endif
         col_accul = pads(1,4)+len(pads(1,1))
         if at('\',pads(1,1)) > 0
            col_accul = col_accul-1
         endif
         if left(pads(1,1),1) = '\'
            set color to &unsel_colo
            @ pads(1,3),pads(1,4) say right(pads(1,1),len(pads(1,1))-1)
         else
            set color to &disp_color
            @ pads(1,3),pads(1,4) say pads(1,1)
            do _highlite with 1
         endif
         for pad_num=2 to num_pads
            if type('pads(pad_num,3)')='L'.AND.type('pads(pad_num,4)')='L'
               pads(pad_num,3) = pads(pad_num-1,3)
               pads(pad_num,4) = col_accul+1
            else
               pads(pad_num,3) = iif(type('pads(pad_num,3)')='L', pads(pad_num-1,3), pads(pad_num,3))
               pads(pad_num,4) = iif(type('pads(pad_num,4)')='L', pads(pad_num-1,4), pads(pad_num,4))
            endif
            col_accul = pads(pad_num,4) + len(pads(pad_num,1))
            if at('\',pads(pad_num,1)) > 0
               col_accul = col_accul - 1
            endif
            if left(pads(pad_num,1),1) = '\'
               set color to &unsel_colo
               @ pads(pad_num,3),pads(pad_num,4) say right(pads(pad_num,1),len(pads(pad_num,1))-1)
            else
               set color to &disp_color
               @ pads(pad_num,3),pads(pad_num,4) say pads(pad_num,1)
               do _highlite with pad_num
            endif
         endfor
         redraw = .F. && redraw not needed if this process has run
         pad_num=1
         * Display menu items and set up the hot keys
      endif
      set exact &save_exact
      if redraw
         for pad_num=1 to num_pads
            if left(pads(pad_num,1),1) = '\'
               set color to &unsel_colo
               @ pads(pad_num,3),pads(pad_num,4) say right(pads(pad_num,1),len(pads(pad_num,1))-1)
            else
               set color to &disp_color
               @ pads(pad_num,3),pads(pad_num,4) say pads(pad_num,1)
               do _highlite with pad_num
            endif
         endfor
      endif
      * Accept keyboard input and process
      * display error message
      if left(pads(old_pos,1),1) = '\'
         do disp_msg_ with 'The procedure menu_ was called with a menu item'+chr(13)+'that is unselectable'+chr(13)+chr(13)+'Press enter and the procedure will continue'+chr(13)+' with the next possible menu item selected',900,.F.,.F.,.F.,.F.,.F.,.F.,.F.,.F.,.T.
      endif
      right_arrow = .T.
      draw = .T.
      ext = .F.
      do while .T.
         * skip over unselectable pads
         do while left(pads(start_pos,1),1) = '\'
            if right_arrow
               start_pos = iif(start_pos=num_pads, 1, start_pos+1)
            else
               start_pos = iif(start_pos=1, num_pads, start_pos-1)
            endif
         enddo
         if draw
            * (if) statement needed for when the procedure is called with an unselectable menu item
            if left(pads(old_pos,1),1) <> '\'
               set color to &disp_color
               @ pads(old_pos,3),pads(old_pos,4) say pads(old_pos,1)
               do _highlite with old_pos
            endif
            set color to &sel_color
            @ pads(start_pos,3),pads(start_pos,4) say pads(start_pos,1)
            set color to &mess_color
            @ iif(message_line>wrows(),wrows()-1,message_line),0 clear to iif(message_line>wrows(),wrows()-1,message_line),79
            * find offset for start of message
            do case
               case message_place = 'L'
                  mess_y = 0
               case message_place = 'C'
                  mess_y = (wcols()-len(pads(start_pos,2)))/2
               otherwise
                  mess_y = wcols()-len(pads(start_pos,2))
            endcase
            @ iif(message_line>wrows(),wrows()-1,message_line),mess_y say pads(start_pos,2)
         endif
         old_pos = start_pos
         draw = .F.
         if ext
            ans = 13 && could have keyboarded a chr(13), however it may have effected the keyboard buffer
         else
            ans = inkey(0)
         endif
         do case
            * F1 pressed
            case ans=28.AND.help
***  Delete comment on the next ilne if help_ smart procedure is installed
***  or add your own command
*** use menu_name+' '+upper(pads(start_pos,1)) as a key lookup field
*              do help_ with help_file,help_update
            * enter/space bar
            case ans = 13 .OR. ans = 32
               mstart_pos = start_pos && save current location for possable return to same menu
               set cursor &save_curso
               set color of scheme 1 to &savecolor1
               set color of scheme 2 to &savecolor2
               mstart_pos = start_pos
               return upper(pads(start_pos,1))
            * hot key character pressed
            case ans>32 .AND. upper(chr(ans)) $ hotkeys
               * find hit from current position to end of hotkeys
               *   before looking from the first position
               fkey = upper(chr(ans))
               for a=start_pos to len(hotkeys)
                  if substr(hotkeys,a,1)=fkey
                     exit
                  endif
               endfor
               if a>len(hotkeys)
                  start_pos = at(upper(chr(ans)),hotkeys)
               else
                  start_pos = a
               endif
               if set('CONFIRM') = 'OFF'
                  ext = .T.
               endif
               draw = .T.
            * left arrow
            case ans = 19 .OR. ans = 52
               start_pos = iif(start_pos=1, num_pads, start_pos-1)
               right_arrow = .F.
               draw = .T.
            * right arrow
            case ans = 4 .OR. ans = 54
               start_pos = iif(start_pos=num_pads, 1, start_pos+1)
               right_arrow = .T.
               draw = .T.
            * up arrow
            case ans = 5 .OR. ans = 56
               do RestStat
               return 'UPARROW'
            * down arrow
            case ans = 24 .OR. ans = 50
               do RestStat
               return 'DNARROW'
            * page up
            case ans = 18 .OR. ans = 57
               do RestStat
               return 'PAGEUP'
            * page down
            case ans = 3 .OR. ans = 51
              do RestStat
              return 'PAGEDOWN'
            case ans = 23
              do RestStat
              return 'CTRL-W'
            case ans = 27
              do RestStat
              return 'ESC PRESSED'
            otherwise
               set console on
               ?? chr(7)
         endcase
      enddo
endcase

return

*
* SUPPORT PROCEDURES TO MENU_
*

procedure _highlite
parameters pad_num

if substr(hotkeys,pad_num,1)<>' '
  hot_pos = at(substr(hotkeys,pad_num,1),pads(pad_num,1))
  if hot_pos>0
     set color to &hot_color
     * -1 offset needed since at() is 1 based and @ say is zero based
     @ pads(pad_num,3),pads(pad_num,4)+hot_pos-1 say substr(pads(pad_num,1),hot_pos,1)
  endif
endif


*

procedure RestStat

   set cursor &save_curso
   set color of scheme 1 to &savecolor1
   set color of scheme 2 to &savecolor2
   mstart_pos = start_pos

return

*

***************************************************************************
*** Procedure menu_defs_  (data structure for procedure menu_ ) version 1.0
*** Copyright 1990, CRAIG KIMPEL
***
***************************************************************************

procedure menu_defs_

* This procedure externalized since it is an independent part of the
* menu_ procedure. This allows the programmer to update the menu_
* procedure and overwrite the old menu_ procedure in programs without
* having to seperate this section of the procedure from the menu_ procedure.

         * terminated by null automatically
* update the global variable to streamline the procedure by not making
* it call this initalization routine unnecessarily
         curr_menu = menu_name 
         do case
* MENU DEFINITION STRUCTURE
*           case menu_name= <menu_name>
*              pads(1,1) = <prompt>
*              pads(1,2) = <message>  && truncated to fit window size if needed
*              pads(1,3) = <row>      && optional Figured out at runtime if needed
*              pads(1,4) = <column>   && optional Figured out at runtime if needed
            case menu_name= 'TEST'
               * both row and column are missing
               pads(1,1) = 'Test1\<'
               pads(1,2) = 'This is a test ONE'
               * column is missing
               pads(2,1) = 't\<Est2'
               pads(2,2) = 'This is a test TWO'
               pads(2,3) = 2
               * row is missing
               pads(3,1) = 'te\St3'
               pads(3,2) = 'This is a test THREE'
               pads(3,4) = 20
               * row and column are both filled in
               pads(4,1) = 'tes\<T4'
               pads(4,2) = 'This is a test 4'
               pads(4,3) = 10
               pads(4,4) = 10
               * row and column are missing
               pads(5,1) = 'test\<5'
               pads(5,2) = 'This is a test 5'
            case menu_name= 'TEST1'
               * both row and column are missing
               pads(1,1) = 'Test1'
               pads(1,2) = 'This is a test ONE and this line is to long for display window so truncate it *|***************************'
               * column is missing
               pads(2,1) = 't\<Est2'
               pads(2,2) = 'This is a test TWO'
               pads(2,3) = 2
               * row is missing
               pads(3,1) = 'te\St3'
               pads(3,2) = 'This is a test THREE'
               pads(3,4) = 20
               * row and column are both filled in
               pads(4,1) = 'tes\<T4'
               pads(4,2) = 'This is a test 4'
               pads(4,3) = 10
               pads(4,4) = 10
               * row and column are missing
               pads(5,1) = 'test\<5'
               pads(5,2) = 'This is a test 5'
            otherwise
               do disp_msg_ with 'Menu name parameter '+menu_name+chr(13)+'in procedure menu_ NOT FOUND',999,.T.,.F.,.F.,.F.,.F.,.F.,.F.,.F.,.T.
               if develop
                  suspend
               else
                  cancel
               endif
         endcase

return

*
